#pragma once

//disable inheritance warning caused by multiple inheritance
#if _WIN32
#if _MSC_VER
#pragma warning(disable: 4250)
#endif
#endif

#include "OgreRenderingRun.h"
#include "OgreSharedRuns.h"


/**
	@brief ColorCubeMapRenderingRun used in an OGRE environment.
*/
class OgrePMEntryPointMapRenderingRun : public OgreRenderingRun									
{	
public:

	/**
		@brief Constructor.

		
	*/	
	OgrePMEntryPointMapRenderingRun(String name);
	/**
		@brief returns the name of the camera depth texture
	*/
	String getEntryPointTextureName(){return name;}
	
protected:
	/**
		@brief the name of the entry point texture that was created by this run
	*/
	String name;
	/**
		@brief a pointer to the scene depth texture that was created by this run
	*/
	Texture* entryPointTexture;
	
	//inherited
	void updateFrame(unsigned long frameNum);	
	
	inline void createEntryPointMap();

	bool needUpdate(unsigned long frameNum )
	{
		return true;
	}

};
