#include "OgrePMEntryPointMapRenderingRun.h"
#include "OgreIlluminationManager.h"

OgrePMEntryPointMapRenderingRun::OgrePMEntryPointMapRenderingRun(String name)
														   : OgreRenderingRun(1, 1)
														   , RenderingRun(1, 1)
{
	this->name = name;
	
	createEntryPointMap();	
}

void OgrePMEntryPointMapRenderingRun::createEntryPointMap()
{
	unsigned int entryPointCnt = OgreIlluminationManager::getSingleton().getPathMapEntryPoints().size();
	int width = entryPointCnt / 4096 * 2;
	int height = 4096;
	TexturePtr texPtr = Ogre::TextureManager::getSingleton().createManual(name, 
																		"default",
																		TEX_TYPE_2D,
																		width,
																		height,
																		0,
																		0,
																		PF_FLOAT32_RGBA,
																		TU_DEFAULT);
	entryPointTexture = texPtr.getPointer();
	
	struct TMR
	{
		float pos[4];
		float dir[4];
	};
	TMR* tm = new TMR[entryPointCnt];
	for(int i=0; i<entryPointCnt; i++)
	{
		PathMapEntryPoint* EP = &OgreIlluminationManager::getSingleton().getPathMapEntryPoints().at(i);
		tm[i].pos[0] = EP->position.x;
		tm[i].pos[1] = EP->position.y;
		tm[i].pos[2] = EP->position.z;
		tm[i].pos[3] = 1.0;
		tm[i].dir[0] = EP->normal.x;
		tm[i].dir[1] = EP->normal.y;
		tm[i].dir[2] = EP->normal.z;
		tm[i].dir[3] = 1.0;
	}	

	PixelBox lockBox(width, height, 1, PF_FLOAT32_RGBA, tm);
	entryPointTexture->getBuffer()->blitFromMemory(lockBox);
}

void OgrePMEntryPointMapRenderingRun::updateFrame(unsigned long frameNum)
{	
	
}


